# LoopVectorization.jl

This documentation is for 
[`LoopVectorization.jl`](https://github.com/JuliaSIMD/LoopVectorization.jl).
Please [file an issue](https://github.com/JuliaSIMD/LoopVectorization.jl/issues/new) 
if you run into any problems.

## Manual Outline

```@contents
Pages = [
    "getting_started.md",
    "examples/multithreading.md",
    "examples/matrix_multiplication.md",
    "examples/array_interface.md",
    "examples/matrix_vector_ops.md",
    "examples/dot_product.md",
    "examples/filtering.md",
    "examples/special_functions.md",
    "examples/sum_of_squared_error.md",
    "vectorized_convenience_functions.md",
    "future_work.md",
    "devdocs/overview.md",
    "devdocs/loopset_structure.md",
    "devdocs/constructing_loopsets.md",
    "devdocs/evaluating_loops.md",
    "devdocs/lowering.md"
]
Depth = 1
```


